<?php

namespace Drupal\vardumper\VarDumper;

use Symfony\Component\HttpFoundation\Session\Session;
use Symfony\Component\VarDumper\Cloner\VarCloner;
use Symfony\Component\VarDumper\Dumper\CliDumper;
use Drupal\vardumper\VarDumper\Dumper\HtmlDrupalDumper;
use Symfony\Component\VarDumper\VarDumper;
use Symfony\Component\HttpFoundation\Session\SessionInterface;

class VarDumperBlock {

  /**
   * The Session service.
   *
   * @var Session;
   */
  protected $session;

  public function __construct(SessionInterface $session) {
    $this->session = $session;
  }

  public function dump($var, $name = '') {
    $_ = array_reverse(debug_backtrace());
    while($d = array_pop($_)) {
      if ((strpos(@$d['file'], 'krumo') === FALSE) && @$d['class'] != 'krumo') {
        break;
      }
    }

    if (!empty($name) && is_string($name)) {
      $name = '<strong>' . $name . '</strong> :: ';
    }

    $header = '<em>' . $name . 'Dump called from <strong>' . $d['file'] . '</strong>, line <strong>' . $d['line'] . '</strong></em>';

    $memory = fopen('php://memory', 'r+b');
    $cloner = new VarCloner();
    $dumper = 'cli' === PHP_SAPI ? new CliDumper() : new HtmlDrupalDumper();
    $dumper->dump($cloner->cloneVar($var), $memory);
    $html = $header . stream_get_contents($memory, -1, 0);

    $this->session->getFlashBag()->add('vardumper', $html);
  }

}
