<?php

namespace Drupal\vardumper\VarDumper;

use Drupal\service_container\Messenger\MessengerInterface;
use Symfony\Component\VarDumper\Cloner\VarCloner;
use Symfony\Component\VarDumper\Dumper\CliDumper;
use Drupal\vardumper\VarDumper\Dumper\HtmlDrupalDumper;
use Symfony\Component\VarDumper\VarDumper;

class VarDumperMessage
{
  /**
   * The Messenger service.
   *
   * @var \Drupal\service_container\Messenger\LegacyMessenger
   */
  protected $messenger;

  public function __construct(MessengerInterface $messenger) {
    $this->messenger = $messenger;
  }

  public function dump($var, $name = '')
  {
    $_ = array_reverse(debug_backtrace());
    while($d = array_pop($_)) {
      if ((strpos(@$d['file'], 'krumo') === FALSE) && @$d['class'] != 'krumo') {
        break;
      }
    }

    if (!empty($name) && is_string($name)) {
      $name = '<strong>' . $name . '</strong> :: ';
    }

    $header = '<em>' . $name . 'Dump called from <strong>' . $d['file'] . '</strong>, line <strong>' . $d['line'] . '</strong></em>';

    $memory = fopen('php://memory', 'r+b');
    $cloner = new VarCloner();
    $dumper = 'cli' === PHP_SAPI ? new CliDumper() : new HtmlDrupalDumper();
    $dumper->dump($cloner->cloneVar($var), $memory);
    $html = $header . stream_get_contents($memory, -1, 0);

    $this->messenger->addMessage($html, 'status', FALSE);
  }

}
